=== debian/changelog ===
mirall (1.6.3-rd1) lucid; urgency=low

  * use tlsv1 for https to avoid using ssl3

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Sat, 18 Oct 2014 23:18:26 +0100
