=== debian/changelog ===
mirall (1.6.4) lucid; urgency=low

  * port new upstream version

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Wed, 22 Oct 2014 23:18:26 +0100
