=== debian/control ===
Source: mirall
Section: unknown
Priority: extra
Maintainer: Ralf Dragon <dragon@vision.ee.ethz.ch>
Build-Depends: debhelper (>= 7), cmake, libneon27-dev, libneon27, maemo-optify, libqt4-dev, qtkeychain-dev, qtkeychain
Build-Conflicts: ocsync
Standards-Version: 3.8.3
Homepage: http://download.owncloud.com

Package: mirall
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libneon27, qtkeychain
Conflicts: ocsync
Description: Owncloud command line client
